Subject: Re: bug#47889: [installer image] grub-install efi fails getting canonical path to /boot/efi on dos-formatted disk

From: Ludovic Courtès <[email-masked]>
Date: Fri, 23 Apr 2021 12:39:13 +0200

Hi Florian,

(Cc: Mathieu.)

"pelzflorian (Florian Pelz)" <[email-masked]> skribis:

> On Thu, Apr 22, 2021 at 03:28:39PM +0200, Ludovic Courtès wrote:
>> There’s no EFI (vfat) partition here.  Is it an EFI machine?
>> 
>> Is /boot/efi mounted when you boot the installation image?
>
> No because there is no EFI partition.  If I create one and restart the
> installer, then it is *not* mounted either, only /mnt/boot/efi later
> during the install.  (I believe since the installer is installed as on
> an external medium, it does not need an EFI partition.)
>
> I had booted the install image via UEFI boot and had expected auto
> partitioning and the default configuration to do the right thing.

The installer determines whether it’s doing a UEFI installation like so:

  (define (efi-installation?)
    "Return #t if an EFI installation should be performed, #f otherwise."
    (file-exists? "/sys/firmware/efi"))

It uses that to determine whether to create an EFI System Partition
(ESP) and whether to use ‘grub-efi-bootloader’.

Did it create an ESP in your case?

I’m not entirely sure how it decides between GPT and DOS, though;
Mathieu?

We should add UEFI installation tests using OVMF.

Thanks,
Ludo’.